#include "stdafx.h"
#include "PaintProcs.h"
#include "Main.h"

LPCTSTR szTitle=_T("");					
LPCTSTR szWindowClass="main_window_cls";

//-------------------------------------------------------

union KeyState
{
	struct  
	{
		unsigned __int32 repeat_count:16;
		unsigned __int32 scan_code_oem:8;
		unsigned __int32 ext_key:1;
		unsigned __int32 reserved:4;
		unsigned __int32 context_code:1;
		unsigned __int32 previous_state_pressed:1;
		unsigned __int32 transition_state:1;
	};
	unsigned __int32 l_param;
};

bool On_WM_Mouse(HWND hwnd, UINT m, WPARAM w, LPARAM l)
{
	int		x=LOWORD(l);
	int		y=HIWORD(l);
	DWORD	key_indicators=w;

	switch(m) 
	{
	case WM_RBUTTONDOWN:   
		OnMouseEvent(me_rbuttondown,x,y,key_indicators);
		break;
	case WM_RBUTTONUP:
		OnMouseEvent(me_rbuttonup,x,y,key_indicators);
		break;
	case WM_LBUTTONDOWN:
		OnMouseEvent(me_lbuttondown,x,y,key_indicators);
		break;
	case WM_LBUTTONUP:
		OnMouseEvent(me_lbuttonup,x,y,key_indicators);
		break;
	case WM_MOUSEMOVE:
		OnMouseEvent(me_mousemove,x,y,key_indicators);
		break;
	}

	return false;
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch(message) 
	{
	case WM_ERASEBKGND:
		return TRUE;
	case WM_PAINT:
// 		{//  
// 			PAINTSTRUCT ps;
// 			HDC dc = BeginPaint(hWnd, &ps);
// 			PaintObjectsPrepare(dc, ps.rcPaint.right - ps.rcPaint.left, 
// 							ps.rcPaint.bottom - ps.rcPaint.top);
// 			EndPaint(hWnd, &ps);
// 		}
		{//  
			PAINTSTRUCT ps;
			HDC dc = BeginPaint(hWnd, &ps);

			RECT		rect;

			GetClientRect(hWnd,&rect);

			HBITMAP bmp=CreateCompatibleBitmap(dc, rect.right-rect.left, rect.bottom-rect.top);
			HDC mdc=CreateCompatibleDC(dc);

			HGDIOBJ old_bmp=SelectObject(mdc,bmp);

			HBRUSH brush=GetSysColorBrush( CTLCOLOR_STATIC );
			HGDIOBJ old_brush=SelectObject(mdc,brush);
			BitBlt(mdc,0,0, rect.right, rect.bottom, NULL,0,0,PATCOPY);
			SelectObject(mdc,old_brush);

			PaintObjectsPrepare(mdc, rect.right - rect.left, 
										rect.bottom - rect.top);

			BitBlt(dc,0,0, rect.right, rect.bottom, mdc,0,0,SRCCOPY);

			SelectObject(mdc,old_bmp);

			DeleteDC(mdc);
			DeleteObject(bmp);
			ReleaseDC(hWnd,dc);

			EndPaint(hWnd, &ps);
		}
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	case WM_TIMER:
		RedrawWindow(hWnd,NULL,NULL,/*RDW_NOERASE|*/RDW_ERASE|RDW_INVALIDATE|RDW_UPDATENOW);
		break;
	case WM_SYSKEYDOWN:
	case WM_SYSKEYUP:
	case WM_KEYDOWN:
	case WM_KEYUP:
		{
			KeyState	ks;
			int			vkey;
			bool		key_down;
			bool		auto_repeat;

			ks.l_param=lParam;
			key_down=(message==WM_SYSKEYDOWN)|(message==WM_KEYDOWN);

			vkey=wParam;
 			auto_repeat=( key_down && (ks.previous_state_pressed==1) );

			OnKeyEvent(key_down,auto_repeat,ks.scan_code_oem,vkey);
		}
		break;
	case WM_RBUTTONDOWN:
	case WM_RBUTTONUP:
	case WM_LBUTTONDOWN:
	case WM_LBUTTONUP:
	case WM_MOUSEMOVE:
		On_WM_Mouse(hWnd, message, wParam, lParam);
		break;
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX	wcex;
	HBRUSH		brush;

	{
		LOGBRUSH		lb;
		lb.lbStyle = BS_SOLID; 
		lb.lbColor = RGB(0,0,0); 
		lb.lbHatch = 0; 
		brush=CreateBrushIndirect(&lb);
	}


	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= brush;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

HWND InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;

	hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

	if(hWnd==NULL)
		return NULL;

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return hWnd;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPTSTR    lpCmdLine,
					   int       nCmdShow)
{
	MSG		msg;

	MyRegisterClass(hInstance);
	g_main_window=InitInstance(hInstance, nCmdShow);

	SetTimer(g_main_window,1,c_paint_object_period_ms,NULL);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (int) msg.wParam;
}
