#include "stdafx.h"
#include "PaintProcs.h"
#include "Main.h"
#include <vector>

struct Bouble
{
	Bouble()
	:destroy(false)
	{
	};

	int radius;
	POINT pos;
	bool destroy;
};

void BoublePaint(HDC dc, Bouble* bouble)
{
	SetFillColorEmpty(dc);
	SetContourLineColor(dc,0,255,255);
	Ellipse(dc, bouble->pos.x - bouble->radius, bouble->pos.y - bouble->radius,
		bouble->pos.x + bouble->radius, bouble->pos.y + bouble->radius);
}

void BoubleMove(Bouble* bouble)
{
	bouble->pos.y -= 5;
	if((bouble->pos.y<0)&& !bouble->destroy)
		bouble->destroy=true;
}

void BoubleProcessDestroy(std::vector<Bouble>* boubles)
{
	for(std::vector<Bouble>::iterator it=boubles->begin(); it!=boubles->end(); )
	{
		if((*it).destroy)
			it=boubles->erase(it);
		else
			it++;
	}
}

//-------------------------------------------------------


struct Fin
{
	bool direction;
	int pos_x;
	int pos_y;
	int dx;
	int dy;
	COLORREF color;
};

void FinPaint1(HDC dc, const POINT& parent_pos, Fin* fin)
{
	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,GetRValue(fin->color),GetGValue(fin->color),GetBValue(fin->color));

	PaintTriangle(dc, fin->pos_x+fin->dx + parent_pos.x, fin->pos_y+fin->dy + parent_pos.y,  
						220-30+fin->dx + parent_pos.x, 200-90+fin->dy + parent_pos.y,  
						170-30+fin->dx + parent_pos.x, 200-90+fin->dy + parent_pos.y);
}

void FinPaint2(HDC dc, const POINT& parent_pos, Fin* fin)
{
	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,GetRValue(fin->color),GetGValue(fin->color),GetBValue(fin->color));

	MoveToEx(dc,220-30+fin->dx + parent_pos.x, 200-90+fin->dy + parent_pos.y,NULL);
	LineTo(dc,200-30+fin->dx + parent_pos.x, 210-90+fin->dy + parent_pos.y);
	LineTo(dc,170-30+fin->dx + parent_pos.x, 200-90+fin->dy + parent_pos.y);
	LineTo(dc,fin->pos_x+fin->dx + parent_pos.x, fin->pos_y+fin->dy + parent_pos.y);
	LineTo(dc,220-30+fin->dx + parent_pos.x, 200-90+fin->dy + parent_pos.y);
}

void FinMove1(Fin* fin)
{
	if(fin->direction)
		fin->pos_x+=10;
	else 
		fin->pos_x-=10;
	if(fin->pos_x>220-30)
		fin->direction= ! fin->direction;
	if(fin->pos_x<160-30)
		fin->direction= ! fin->direction;

}

void FinMove2(Fin* fin)
{
	if(fin->direction)
		fin->pos_y+=10;
	else 
		fin->pos_y-=10;
	if(fin->pos_y> 250-90)
		fin->direction= false;
	if(fin->pos_y< 200-90)
		fin->direction= true;
}

struct Fish
{
	Fin fin1;
	Fin fin2;
	POINT pos;
	bool direction_right;
	int boudle_skip;
	int direction_angle;
};

void FishPaint(HDC dc, Fish* fish)
{
	SetFillColor(dc,0,255,0);
	SetFillColorEmpty(dc);

	SetContourLineColor(dc,255,0,0);
	Ellipse(dc, fish->pos.x+80-30, fish->pos.y+90-90,  
				fish->pos.x+290-30, fish->pos.y+225-90);

	FinPaint1(dc, fish->pos, &fish->fin1);
	FinPaint2(dc, fish->pos, &fish->fin2);

	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,255,0,0);
	Ellipse(dc, fish->pos.x+230-30, fish->pos.y+140-90,  
				fish->pos.x+260-30, fish->pos.y+170-90);
	Ellipse(dc, fish->pos.x+245-30, fish->pos.y+150-90,  
				fish->pos.x+255-30, fish->pos.y+160-90);

	MoveToEx(dc, fish->pos.x+270-30, fish->pos.y+170-90, NULL);
	LineTo(dc, fish->pos.x+288-30, fish->pos.y+165-90);


	MoveToEx(dc, fish->pos.x+80-30, fish->pos.y+145-90, NULL);
	LineTo(dc, fish->pos.x+30-30, fish->pos.y+115-90);
	LineTo(dc, fish->pos.x+30-30, fish->pos.y+190-90);
	LineTo(dc, fish->pos.x+80-30, fish->pos.y+170-90);
}

void FishProcessAddBouble(Fish* fish, std::vector<Bouble>* boubles)
{
	if(fish->boudle_skip==0)
	{
		fish->boudle_skip=9;
		Bouble item;
		item.pos.x=fish->pos.x+260;
		item.pos.y=fish->pos.y+70;
		item.radius=10;
		item.destroy=false;
		boubles->push_back(item);
	}
	fish->boudle_skip--;
}

void FishMove1(Fish* fish, std::vector<Bouble>* boubles)
{
	FinMove1(&fish->fin1);
	FinMove2(&fish->fin2);

	if(fish->direction_right)
		fish->pos.x+=10;
	else 
		fish->pos.x-=10;
	if(fish->pos.x> 500-30)
		fish->direction_right= false;
	if(fish->pos.x< -10-30)
		fish->direction_right= true;

	FishProcessAddBouble(fish,boubles);
}

void FishMove2(Fish* fish)
{
	if(fish->direction_right)
		FinMove1(&fish->fin1);
	else
		FinMove2(&fish->fin1);
	FinMove2(&fish->fin2);

	if(fish->direction_right)
		fish->pos.y+=10;
	else 
		fish->pos.y-=10;
	if(fish->pos.y> 250+90)
		fish->direction_right= false;
	if(fish->pos.y< -50+90)
		fish->direction_right= true;
}

void FishMoveControl(Fish* fish)
{	
	bool up_down=false;

	if( ((fish->direction_angle>=0) && (fish->direction_angle<90)) ||
		((fish->direction_angle>270) && (fish->direction_angle<=360)) )
		fish->pos.x+=10;
	else if( (fish->direction_angle>90) && (fish->direction_angle<270) )
		fish->pos.x-=10;
	
	if( (fish->direction_angle>0) && (fish->direction_angle<180) )
	{
		fish->pos.y-=10;
		up_down=true;
	}
	else if( (fish->direction_angle>180) && (fish->direction_angle<360) )
	{
		fish->pos.y+=10;
		up_down=true;
	}

	if(up_down)
	{
		FinMove2(&fish->fin1);
		FinMove2(&fish->fin2);
	}
	else
	{
		FinMove1(&fish->fin1);
		FinMove1(&fish->fin2);
	}
}

int g_mouse_x;
int g_mouse_y;
const int c_paint_object_period_ms=40;

struct Cls
{
	int a;
	double b;


	Bouble operator[] (char* val)
	{
		return Bouble();
	}

};

std::vector<Bouble> g_boubles;
Fish* g_fish_control=NULL;

void PaintObjects(HDC dc,  int width, int hight)
{

// 	SetFillColor(0,255,0);
// 	SetFillColorEmpty();
// 
// 	SetContourLineColor(255,0,0);
// 	Ellipse(dc, 80, 90,  290, 225);


//-------------------------------------------------------


	static Fish fish0={{true,160-30,230-90,-40,0,RGB(0,255,0)}, {false,200-30,230-90,+20,-15,RGB(0,0,255)}, {100,100}, true,0,-1 };
	static Fish fish1={{true,160,230-90,-40,0,RGB(0,255,0)}, {false,200,230-90,+20,-15,RGB(0,0,255)}, {250,100}, false,0,-1 };
	static Fish fish2={{true,160,230,-40,0,RGB(0,255,0)}, {false,200,230,+20,-15,RGB(0,0,255)}, {200,50}, true,0,-1 };
	static bool init=false;
	if(!init)
	{
		init=true;

		g_fish_control=&fish0;

		Bouble item;
		item.pos.x=100;
		item.pos.y=100;
		item.radius=5;
		g_boubles.push_back(item);
	}

	FishPaint(dc,&fish0);

 	FishPaint(dc,&fish1);
 	FishPaint(dc,&fish2);

	for(size_t i=0; i<g_boubles.size(); i++)
		BoublePaint(dc,&g_boubles[i]);

	FishMoveControl(&fish0);
	FishProcessAddBouble(&fish0,&g_boubles);
	//FishMove1(&fish0, &g_boubles);
 	FishMove1(&fish1, &g_boubles);
 	FishMove2(&fish2);

	for(size_t i=0; i<g_boubles.size(); i++)
		BoubleMove(&g_boubles[i]);
	BoubleProcessDestroy(&g_boubles);

// -------------------------------------------------------

	{
		char str[256];

		SetTextColor(dc,RGB(0,0,0));
		SetBkColor(dc,RGB(255,255,255));
		sprintf(str,"X %i",(int)(g_mouse_x));
		PaintText(dc, 0,0,str);
		sprintf(str,"Y %i",(int)(g_mouse_y));
		PaintText(dc, 60,0,str);
	}

}

void OnKeyEvent(bool key_down, bool auto_repeat, int scan_code, int virtual_code)
{
	enum KeyIndex {ki_up=0,ki_down,ki_left,ki_right,ki_count};
	static bool s_key_state[ki_count]={false,false,false,false};

	switch(virtual_code)
	{
	case VK_UP: s_key_state[ki_up]=key_down; break;
	case VK_DOWN: s_key_state[ki_down]=key_down; break;
	case VK_LEFT: s_key_state[ki_left]=key_down; break;
	case VK_RIGHT: s_key_state[ki_right]=key_down; break;
	}

	if(g_fish_control!=NULL)
	{
		if(s_key_state[ki_up]&&s_key_state[ki_right])
			g_fish_control->direction_angle=45;
		else if(s_key_state[ki_up]&&s_key_state[ki_left])
			g_fish_control->direction_angle=135;
		else if(s_key_state[ki_down]&&s_key_state[ki_left])
			g_fish_control->direction_angle=225;
		else if(s_key_state[ki_down]&&s_key_state[ki_right])
			g_fish_control->direction_angle=325;
		else if(s_key_state[ki_right])
			g_fish_control->direction_angle=0;
		else if(s_key_state[ki_up])
			g_fish_control->direction_angle=90;
		else if(s_key_state[ki_left])
			g_fish_control->direction_angle=180;
		else if(s_key_state[ki_down])
			g_fish_control->direction_angle=270;
		else 
			g_fish_control->direction_angle=-1;
	}

}

void OnMouseEvent(MouseEventType event_type, int x, int y, DWORD key_indicators)
{
	g_mouse_x=x;
	g_mouse_y=y;
	PaintUpdateNow(g_main_window);

	if(event_type==me_lbuttonup)
	{
		char str[256];
		sprintf(str,"%i, %i\r\n",(int)(g_mouse_x),(int)(g_mouse_y));
		OutputDebugString(str);
	}
	if(event_type==me_rbuttonup)
		OutputDebugString("-X----Y-\r\n");
}

