#include "stdafx.h"
#include "PaintProcs.h"
#include "Main.h"

int g_mouse_x;
int g_mouse_y;
const int c_paint_object_period_ms=500;
       
struct Fin
{
	bool direction;
	int pos_x;
	int pos_y;
	int dx;
	int dy;
	COLORREF color;
};

void FinPaint1(HDC dc, Fin* fin)
{
	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,GetRValue(fin->color),GetGValue(fin->color),GetBValue(fin->color));

	PaintTriangle(dc, fin->pos_x+fin->dx, fin->pos_y+fin->dy,  220+fin->dx, 200+fin->dy,  170+fin->dx, 200+fin->dy);
}

void FinPaint2(HDC dc, Fin* fin)
{
	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,GetRValue(fin->color),GetGValue(fin->color),GetBValue(fin->color));

	MoveToEx(dc,220+fin->dx, 200+fin->dy,NULL);
	LineTo(dc,200+fin->dx, 210+fin->dy);
	LineTo(dc,170+fin->dx, 200+fin->dy);
	LineTo(dc,fin->pos_x+fin->dx, fin->pos_y+fin->dy);
	LineTo(dc,220+fin->dx, 200+fin->dy);
}

void FinMove1(Fin* fin)
{
	if(fin->direction)
		fin->pos_x+=10;
	else 
		fin->pos_x-=10;
	if(fin->pos_x>220)
		fin->direction= ! fin->direction;
	if(fin->pos_x<160)
		fin->direction= ! fin->direction;
}

void FinMove2(Fin* fin)
{
	if(fin->direction)
		fin->pos_y+=10;
	else 
		fin->pos_y-=10;
	if(fin->pos_y> 250)
		fin->direction= ! fin->direction;
	if(fin->pos_y< 200)
		fin->direction= ! fin->direction;
}

void PaintObjects(HDC dc,  int width, int hight)
{
// 	SetFillColor(0,255,0);
// 	SetFillColorEmpty();
// 
// 	SetContourLineColor(255,0,0);
// 	Ellipse(dc, 80, 90,  290, 225);


//-------------------------------------------------------

	SetFillColor(dc,0,255,0);
	SetFillColorEmpty(dc);
	
	SetContourLineColor(dc,255,0,0);
	Ellipse(dc, 80, 90,  290, 225);

	//     
	//   : static bool init=InitProc();
	static Fin fin1={true,160,230,-40,0,RGB(0,255,0)};
	static Fin fin2;
	static bool init=false;
	if(!init)
	{
		init=true;
		fin2.direction=false;
		fin2.pos_x=200;
		fin2.pos_y=230;
		fin2.dx= +20;
		fin2.dy= -15;
		fin2.color=RGB(0,0,255);
	}


	FinPaint1(dc, &fin1);
	FinPaint2(dc, &fin2);

	FinMove1(&fin1);
	FinMove2(&fin2);
	
	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,255,0,0);
	Ellipse(dc, 230, 140,  260, 170);
	Ellipse(dc, 245, 150,  255, 160);
	
	MoveToEx(dc, 270, 170, NULL);
	LineTo(dc, 288, 165);


	MoveToEx(dc, 80, 145, NULL);
	LineTo(dc, 30, 115);
	LineTo(dc, 30, 190);
	LineTo(dc, 80, 170);

// -------------------------------------------------------

	{
		char str[256];

		SetTextColor(dc,RGB(0,0,0));
		SetBkColor(dc,RGB(255,255,255));
		sprintf(str,"X %i",(int)(g_mouse_x));
		PaintText(dc, 0,0,str);
		sprintf(str,"Y %i",(int)(g_mouse_y));
		PaintText(dc, 60,0,str);
	}

}

void OnKeyEvent(bool key_down, bool auto_repeat, int scan_code, int virtual_code)
{
}

void OnMouseEvent(MouseEventType event_type, int x, int y, DWORD key_indicators)
{
	g_mouse_x=x;
	g_mouse_y=y;
	PaintUpdateNow(g_main_window);

	if(event_type==me_lbuttonup)
	{
		char str[256];
		sprintf(str,"%i, %i\r\n",(int)(g_mouse_x),(int)(g_mouse_y));
		OutputDebugString(str);
	}
	if(event_type==me_rbuttonup)
		OutputDebugString("-X----Y-\r\n");
}

