#include "stdafx.h"
#include "PaintProcs.h"
#include "Main.h"

int g_mouse_x;
int g_mouse_y;
const int c_paint_object_period_ms=500;
       
struct Fin
{
	bool direction;
	int pos_x;
	int pos_y;
	int dx;
	int dy;
	COLORREF color;
};

void FinPaint1(HDC dc, const POINT& parent_pos, Fin* fin)
{
	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,GetRValue(fin->color),GetGValue(fin->color),GetBValue(fin->color));

	PaintTriangle(dc, fin->pos_x+fin->dx + parent_pos.x, fin->pos_y+fin->dy + parent_pos.y,  
						220+fin->dx + parent_pos.x, 200+fin->dy + parent_pos.y,  
						170+fin->dx + parent_pos.x, 200+fin->dy + parent_pos.y);
}

void FinPaint2(HDC dc, const POINT& parent_pos, Fin* fin)
{
	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,GetRValue(fin->color),GetGValue(fin->color),GetBValue(fin->color));

	MoveToEx(dc,220+fin->dx + parent_pos.x, 200+fin->dy + parent_pos.y,NULL);
	LineTo(dc,200+fin->dx + parent_pos.x, 210+fin->dy + parent_pos.y);
	LineTo(dc,170+fin->dx + parent_pos.x, 200+fin->dy + parent_pos.y);
	LineTo(dc,fin->pos_x+fin->dx + parent_pos.x, fin->pos_y+fin->dy + parent_pos.y);
	LineTo(dc,220+fin->dx + parent_pos.x, 200+fin->dy + parent_pos.y);
}

void FinMove1(Fin* fin)
{
	if(fin->direction)
		fin->pos_x+=10;
	else 
		fin->pos_x-=10;
	if(fin->pos_x>220)
		fin->direction= ! fin->direction;
	if(fin->pos_x<160)
		fin->direction= ! fin->direction;
}

void FinMove2(Fin* fin)
{
	if(fin->direction)
		fin->pos_y+=10;
	else 
		fin->pos_y-=10;
	if(fin->pos_y> 250)
		fin->direction= ! fin->direction;
	if(fin->pos_y< 200)
		fin->direction= ! fin->direction;
}

struct Fish
{
	Fin fin1;
	Fin fin2;
	POINT pos;
};

void PaintFish(HDC dc, Fish* fish)
{
	SetFillColor(dc,0,255,0);
	SetFillColorEmpty(dc);

	SetContourLineColor(dc,255,0,0);
	Ellipse(dc, fish->pos.x+80, fish->pos.y+90,  fish->pos.x+290, fish->pos.y+225);

	FinPaint1(dc, fish->pos, &fish->fin1);
	FinPaint2(dc, fish->pos, &fish->fin2);

	FinMove1(&fish->fin1);
	FinMove2(&fish->fin2);

	SetFillColor(dc, 0,0,0);
	SetContourLineColor(dc,255,0,0);
	Ellipse(dc, fish->pos.x+230, fish->pos.y+140,  fish->pos.x+260, fish->pos.y+170);
	Ellipse(dc, fish->pos.x+245, fish->pos.y+150,  fish->pos.x+255, fish->pos.y+160);

	MoveToEx(dc, fish->pos.x+270, fish->pos.y+170, NULL);
	LineTo(dc, fish->pos.x+288, fish->pos.y+165);


	MoveToEx(dc, fish->pos.x+80, fish->pos.y+145, NULL);
	LineTo(dc, fish->pos.x+30, fish->pos.y+115);
	LineTo(dc, fish->pos.x+30, fish->pos.y+190);
	LineTo(dc, fish->pos.x+80, fish->pos.y+170);
}

void PaintObjects(HDC dc,  int width, int hight)
{
// 	SetFillColor(0,255,0);
// 	SetFillColorEmpty();
// 
// 	SetContourLineColor(255,0,0);
// 	Ellipse(dc, 80, 90,  290, 225);


//-------------------------------------------------------


	static Fish fish1={{true,160,230,-40,0,RGB(0,255,0)}, {false,200,230,+20,-15,RGB(0,0,255)}, {100,100} };
	static Fish fish2={{true,160,230,-40,0,RGB(0,255,0)}, {false,200,230,+20,-15,RGB(0,0,255)}, {200,-50} };
	static bool init=false;
	if(!init)
	{
		init=true;
	}

	PaintFish(dc,&fish1);
	PaintFish(dc,&fish2);



// -------------------------------------------------------

	{
		char str[256];

		SetTextColor(dc,RGB(0,0,0));
		SetBkColor(dc,RGB(255,255,255));
		sprintf(str,"X %i",(int)(g_mouse_x));
		PaintText(dc, 0,0,str);
		sprintf(str,"Y %i",(int)(g_mouse_y));
		PaintText(dc, 60,0,str);
	}

}

void OnKeyEvent(bool key_down, bool auto_repeat, int scan_code, int virtual_code)
{
}

void OnMouseEvent(MouseEventType event_type, int x, int y, DWORD key_indicators)
{
	g_mouse_x=x;
	g_mouse_y=y;
	PaintUpdateNow(g_main_window);

	if(event_type==me_lbuttonup)
	{
		char str[256];
		sprintf(str,"%i, %i\r\n",(int)(g_mouse_x),(int)(g_mouse_y));
		OutputDebugString(str);
	}
	if(event_type==me_rbuttonup)
		OutputDebugString("-X----Y-\r\n");
}

