#include "stdafx.h"
#include "PaintProcs.h"
#include "Main.h"

#define COUNTOF(array) (sizeof(array)/sizeof(array[0]))

HWND	g_main_window;

void PaintObjectsPrepare(HDC dc, int width, int hight)
{
	HGDIOBJ	oroginal_pen;
	HGDIOBJ	oroginal_brush;

	oroginal_pen=GetCurrentObject(dc,OBJ_PEN);
	oroginal_brush=GetCurrentObject(dc,OBJ_BRUSH);

	{
		HGDIOBJ		new_object;
		LOGBRUSH	lb;

		GetObject(oroginal_brush, sizeof(lb), &lb );
		new_object=CreateBrushIndirect(&lb);
		SelectObject(dc,new_object);
	}

	{
		HGDIOBJ	new_object;
		LOGPEN	lp;

		GetObject(oroginal_pen, sizeof(lp), &lp );
		new_object=CreatePenIndirect(&lp);
		SelectObject(dc,new_object);
	}


	PaintObjects(dc,width,hight);

	{
		HGDIOBJ	current_pen;
		HGDIOBJ	current_brush;

		current_pen=SelectObject(dc,oroginal_pen);
		DeleteObject(current_pen);
		current_brush=SelectObject(dc,oroginal_brush);
		DeleteObject(current_brush);
	}
}


void SetFillColor(HDC dc, int red, int green, int blue)
{
	LOGBRUSH	lb;
	HGDIOBJ	current_object;
	HGDIOBJ	new_object;

	lb.lbStyle = BS_SOLID; 
	lb.lbHatch = 0; 
	lb.lbColor = RGB(red,green,blue); 
	new_object=CreateBrushIndirect(&lb);

	current_object=SelectObject(dc,new_object);
 	DeleteObject(current_object);
}

void SetFillColorEmpty(HDC dc)
{
	LOGBRUSH	lb;
	HGDIOBJ		current_object;
	HGDIOBJ		new_object;


	lb.lbStyle = BS_NULL; 
	lb.lbHatch = 0; 
	lb.lbColor = RGB(0,0,0); 
	new_object=CreateBrushIndirect(&lb);

	current_object=SelectObject(dc,new_object);
	DeleteObject(current_object);
}

void SetContourLineColor(HDC dc, int red, int green, int blue)
{
	LOGBRUSH		lb;
	HGDIOBJ		current_object;
	HGDIOBJ		new_object;

	lb.lbStyle = BS_SOLID; 
	lb.lbHatch = 0; 
	lb.lbColor = RGB(red,green,blue); 
	new_object=ExtCreatePen(PS_GEOMETRIC | PS_SOLID, 1, &lb, 0, NULL); 

	current_object=SelectObject(dc,new_object);
	DeleteObject(current_object);
}

void PaintTriangle(HDC dc, int x1, int y1, int x2, int y2, int x3, int y3)
{
	POINT poligon[]={ {x1,y1}, {x2,y2}, {x3,y3}};
	Polygon(dc,poligon,COUNTOF(poligon));
}

void PaintLine(HDC dc, int x1, int y1, int x2, int y2)
{
	POINT line_points[]={ {x1,y1}, {x2,y2} };
	Polyline(dc,line_points,COUNTOF(line_points));
}

void PaintUpdateNow(HWND wnd)
{
	RedrawWindow(wnd,NULL,NULL,/*RDW_NOERASE|*/RDW_ERASE|RDW_INVALIDATE|RDW_UPDATENOW);
}

void PaintText(HDC dc, int x, int y, char* text)
{
	int text_len=strlen(text);
	TextOut(dc,x,y,text,text_len);
}
